﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Microsoft.Office.Interop.Excel;
using System.Text.RegularExpressions;
using System.Data.SqlClient;
using TEST;

namespace ExcelHuiHao
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void btnFile_Click(object sender, EventArgs e)
        {
            OpenFileDialog fileDialog = new OpenFileDialog();
            fileDialog.Multiselect = true;
            fileDialog.Title = "请选择文件";
            fileDialog.Filter = "长得丑不是没有道理的(*.xlsx)|*.xlsx";
            if (fileDialog.ShowDialog() == DialogResult.OK)
            {
                string file = fileDialog.FileName;
                txtFile.Text = file;
            }
        }

        private void btnStart_Click(object sender, EventArgs e)
        {
            if (this.Text == "开始匹配")
            {
                this.Text = "停止匹配";
            }
            else
            {
                this.Text = "开始匹配";
            }
            Microsoft.Office.Interop.Excel.Application excel = new Microsoft.Office.Interop.Excel.Application();
            Microsoft.Office.Interop.Excel.Workbook workbook;
            Microsoft.Office.Interop.Excel.Worksheet worksheet;
            object oMissing = System.Reflection.Missing.Value;//相当null
            workbook = excel.Workbooks.Open(txtFile.Text, oMissing, oMissing, oMissing, oMissing, oMissing, oMissing, oMissing, oMissing, oMissing, oMissing, oMissing, oMissing, oMissing, oMissing);
            worksheet = (Worksheet)workbook.Worksheets[1];
            int rowCount = worksheet.UsedRange.Rows.Count;
            int colCount = worksheet.UsedRange.Columns.Count;
            Microsoft.Office.Interop.Excel.Range range1;
            Microsoft.Office.Interop.Excel.Range range0;
            Microsoft.Office.Interop.Excel.Range range2;
            Microsoft.Office.Interop.Excel.Range range3;
            Microsoft.Office.Interop.Excel.Range range4;
            Microsoft.Office.Interop.Excel.Range range5;
            //System.Data.DataTable dt = new System.Data.DataTable();
            //dt.Columns.Add("序号");
            //dt.Columns.Add("客户单位全称");
            //dt.Columns.Add("归属省份");
            //dt.Columns.Add("客户地址");
            //dt.Columns.Add("联系方式");
            using (SqlConnection connection = new SqlConnection("Data Source=116.204.10.139,18066;Initial Catalog=1688_cj;Persist Security Info=True;User ID=haoling;Password=hltx1qaz@WSX"))
            {
                connection.Open();
                for (int j = 1; j < rowCount; j++)
                {
                    //DataRow dr = dt.NewRow();
                    range0 = worksheet.get_Range(worksheet.Cells[j + 1, 1], worksheet.Cells[j + 1, 1]);
                    range1 = worksheet.get_Range(worksheet.Cells[j + 1, 2], worksheet.Cells[j + 1, 2]);
                    range2 = worksheet.get_Range(worksheet.Cells[j + 1, 3], worksheet.Cells[j + 1, 3]);
                    range3 = worksheet.get_Range(worksheet.Cells[j + 1, 4], worksheet.Cells[j + 1, 4]);
                    range4 = worksheet.get_Range(worksheet.Cells[j + 1, 5], worksheet.Cells[j + 1, 5]);
                    range5 = worksheet.get_Range(worksheet.Cells[j + 1, 6], worksheet.Cells[j + 1, 6]);
                    string ComName = range1.Value2.ToString();
                    list_dt.Items.Insert(0, "正在匹配:" + ComName);

                    string sql = "select ComLinkName,ComAddress,(case when ComLinkPhone='' or ComLinkPhone is null then ComLinkTel else ComLinkPhone end) as lianxifangshi from NBData where ComName=@ComName";
                    using (SqlCommand cmdCompany = new SqlCommand(sql, connection))
                    {
                        cmdCompany.Parameters.Clear();
                        //cmdCompany.CommandType = CommandType.Text;
                        //cmdCompany.CommandText = sql;
                        //cmdCompany.Connection = connection;
                        cmdCompany.Parameters.Add(new SqlParameter("@ComName", ComName));
                        using (SqlDataAdapter da = new SqlDataAdapter(cmdCompany))
                        {
                            System.Data.DataTable tablex = new System.Data.DataTable();
                            try
                            {
                                da.Fill(tablex);
                                cmdCompany.Parameters.Clear();
                            }
                            catch (System.Data.SqlClient.SqlException ex)
                            {

                            }
                            if (tablex.Rows.Count > 0)
                            {
                                string sfaaaa = "";
                                Address(Convert.ToString(tablex.Rows[0]["ComAddress"]), out sfaaaa);
                                range2.Value2 = sfaaaa;
                                range3.Value2 = Convert.ToString(tablex.Rows[0]["ComAddress"]);
                                range4.Value2 = Convert.ToString(tablex.Rows[0]["lianxifangshi"]);
                                range5.Value2 = Convert.ToString(tablex.Rows[0]["ComLinkName"]);
                                list_dt.Items.Insert(0, "匹配数据:" + ComName + ",成功");
                                //dr["序号"] = range0.Value2.ToString();
                                //dr["客户单位全称"] = ComName;
                                //dr["归属省份"] = Address(Convert.ToString(tablex.Rows[0]["ComAddress"]));
                                //dr["客户地址"] = tablex.Rows[0]["ComAddress"];
                                //dr["联系方式"] = tablex.Rows[0]["lianxifangshi"];
                                //dt.Rows.Add(dt);
                            }
                            else
                            {
                                list_dt.Items.Insert(0, "匹配:" + ComName + ",失败,找不到数据");
                            }
                        }
                    }
                }
            }
            //导出数据
            worksheet.SaveAs(txtFile.Text);
            //worksheet.SaveAs(txtFile.Text, oMissing, "", oMissing, oMissing, oMissing, Microsoft.Office.Interop.Excel.XlSaveAsAccessMode.xlNoChange, oMissing, oMissing, oMissing);
            //excel.SaveWorkspace
            excel.Quit();
        }
        public string Address(string address, out string province)
        {
            #region 直辖市
            province = "直辖市";
            MatchCollection matches = Regex.Matches(address, "(?<content>(\u5317\u4eac|\u5929\u6d25|\u91cd\u5e86|\u4e0a\u6d77)$?)", RegexOptions.IgnoreCase);
            if (matches.Count > 0)
            {
                province = matches[0].Groups["content"].Value.Trim() + "市";
                return matches[0].Groups["content"].Value.Trim() + "市";
            }
            #endregion
            #region 河北省
            province = "河北省";
            matches = Regex.Matches(address, "(?<content>(\u6cb3\u5317|\u77f3\u5bb6\u5e84|\u5f20\u5bb6\u53e3|\u627f\u5fb7|\u5510\u5c71|\u79e6\u7687\u5c9b|\u5eca\u574a|\u4fdd\u5b9a|\u6ca7\u5dde|\u8861\u6c34|\u90a2\u53f0|\u90af\u90f8)$?)", RegexOptions.IgnoreCase);
            if (matches.Count > 0)
            {
                return matches[0].Groups["content"].Value.Trim() + "市";
            }
            #endregion
            #region 山西省
            province = "山西省";
            matches = Regex.Matches(address, "(?<content>(\u5c71\u897f|\u592a\u539f|\u5927\u540c|\u6714\u5dde|\u5ffb\u5dde|\u9633\u6cc9|\u664b\u4e2d|\u5415\u6881|\u957f\u6cbb|\u4e34\u6c7e|\u664b\u57ce|\u8fd0\u57ce)$?)", RegexOptions.IgnoreCase);
            if (matches.Count > 0)
            {
                return matches[0].Groups["content"].Value.Trim() + "市";
            }
            #endregion
            #region 内蒙古自治区
            province = "内蒙古自治区";
            matches = Regex.Matches(address, "(?<content>(\u5185\u8499\u53e4|\u547c\u548c\u6d69\u7279|\u547c\u4f26\u8d1d\u5c14|\u901a\u8fbd|\u8d64\u5cf0|\u5df4\u5f66\u6dd6\u5c14|\u4e4c\u5170\u5bdf\u5e03|\u5305\u5934|\u9102\u5c14\u591a\u65af|\u4e4c\u6d77|\u5174\u5b89\u76df|\u9521\u6797\u90ed\u52d2\u76df|\u963f\u62c9\u5584\u76df)$?)", RegexOptions.IgnoreCase);
            if (matches.Count > 0)
            {
                return matches[0].Groups["content"].Value.Trim() + "市";
            }
            #endregion
            #region 黑龙江省
            province = "黑龙江省";
            matches = Regex.Matches(address, "(?<content>(\u9ed1\u9f99\u6c5f|\u54c8\u5c14\u6ee8|\u9ed1\u6cb3|\u4f0a\u6625|\u9f50\u9f50\u54c8\u5c14|\u9e64\u5c97|\u4f73\u6728\u65af|\u53cc\u9e2d\u5c71|\u7ee5\u5316|\u5927\u5e86|\u4e03\u53f0\u6cb3|\u9e21\u897f|\u7261\u4e39\u6c5f|\u5927\u5174\u5b89\u5cad)$?)", RegexOptions.IgnoreCase);
            if (matches.Count > 0)
            {
                return matches[0].Groups["content"].Value.Trim() + "市";
            }
            #endregion
            #region 吉林省
            province = "吉林省";
            matches = Regex.Matches(address, "(?<content>(\u5409\u6797|\u957f\u6625|\u767d\u57ce|\u677e\u539f|\u5409\u6797|\u56db\u5e73|\u8fbd\u6e90|\u767d\u5c71|\u901a\u5316|\u5ef6\u8fb9\u671d\u9c9c\u65cf\u81ea\u6cbb\u5dde|\u6885\u6cb3\u53e3|\u516c\u4e3b\u5cad|\u957f\u767d\u5c71\u7ba1\u59d4\u4f1a)$?)", RegexOptions.IgnoreCase);
            if (matches.Count > 0)
            {
                return matches[0].Groups["content"].Value.Trim() + "市";
            }
            #endregion
            #region 辽宁省
            province = "辽宁省";
            matches = Regex.Matches(address, "(?<content>(\u8fbd\u5b81|\u6c88\u9633|\u94c1\u5cad|\u961c\u65b0|\u629a\u987a|\u671d\u9633|\u672c\u6eaa|\u8fbd\u9633|\u978d\u5c71|\u76d8\u9526|\u9526\u5dde|\u846b\u82a6\u5c9b|\u8425\u53e3|\u4e39\u4e1c|\u5927\u8fde|\u846b\u82a6\u5c9b)$?)", RegexOptions.IgnoreCase);
            if (matches.Count > 0)
            {
                return matches[0].Groups["content"].Value.Trim() + "市";
            }
            #endregion
            #region 浙江省
            province = "浙江省";
            matches = Regex.Matches(address, "(?<content>(\u4e49\u52a1|\u6d59\u6c5f|\u676d\u5dde|\u6e56\u5dde|\u5609\u5174|\u7ecd\u5174|\u821f\u5c71|\u5b81\u6ce2|\u91d1\u534e|\u8862\u5dde|\u53f0\u5dde|\u4e3d\u6c34|\u6e29\u5dde)$?)", RegexOptions.IgnoreCase);
            if (matches.Count > 0)
            {
                return matches[0].Groups["content"].Value.Trim() + "市";
            }
            #endregion
            #region 安徽省
            province = "安徽省";
            matches = Regex.Matches(address, "(?<content>(\u5b89\u5fbd|\u5408\u80a5|\u6dee\u5317|\u4eb3\u5dde|\u5bbf\u5dde|\u868c\u57e0|\u961c\u9633|\u6dee\u5357|\u6ec1\u5dde|\u516d\u5b89|\u9a6c\u978d\u5c71|\u829c\u6e56|\u5ba3\u57ce|\u94dc\u9675|\u6c60\u5dde|\u5b89\u5e86|\u9ec4\u5c71)$?)", RegexOptions.IgnoreCase);
            if (matches.Count > 0)
            {
                return matches[0].Groups["content"].Value.Trim() + "市";
            }
            #endregion
            #region 福建省
            province = "福建省";
            matches = Regex.Matches(address, "(?<content>(\u798f\u5efa|\u798f\u5dde|\u5b81\u5fb7|\u5357\u5e73|\u4e09\u660e|\u8386\u7530|\u9f99\u5ca9|\u6cc9\u5dde|\u6f33\u5dde|\u53a6\u95e8)$?)", RegexOptions.IgnoreCase);
            if (matches.Count > 0)
            {
                return matches[0].Groups["content"].Value.Trim() + "市";
            }
            #endregion
            #region 江西省
            province = "江西省";
            matches = Regex.Matches(address, "(?<content>(\u6c5f\u897f|\u5357\u660c|\u4e5d\u6c5f|\u666f\u5fb7\u9547|\u4e0a\u9976|\u9e70\u6f6d|\u629a\u5dde|\u65b0\u4f59|\u5b9c\u6625|\u840d\u4e61|\u5409\u5b89|\u8d63\u5dde)$?)", RegexOptions.IgnoreCase);
            if (matches.Count > 0)
            {
                return matches[0].Groups["content"].Value.Trim() + "市";
            }
            #endregion
            #region 山东省
            province = "山东省";
            matches = Regex.Matches(address, "(?<content>(\u5c71\u4e1c|\u6d4e\u5357|\u5fb7\u5dde|\u6ee8\u5dde|\u4e1c\u8425|\u70df\u53f0|\u5a01\u6d77|\u6dc4\u535a|\u6f4d\u574a|\u804a\u57ce|\u6cf0\u5b89|\u83b1\u829c|\u9752\u5c9b|\u65e5\u7167|\u6d4e\u5b81|\u83cf\u6cfd|\u4e34\u6c82|\u67a3\u5e84)$?)", RegexOptions.IgnoreCase);
            if (matches.Count > 0)
            {
                return matches[0].Groups["content"].Value.Trim() + "市";
            }
            #endregion
            #region 河南省
            province = "河南省";
            matches = Regex.Matches(address, "(?<content>(\u6cb3\u5357|\u90d1\u5dde|\u5b89\u9633|\u9e64\u58c1|\u6fee\u9633|\u65b0\u4e61|\u7126\u4f5c|\u4e09\u95e8\u5ce1|\u5f00\u5c01|\u6d1b\u9633|\u5546\u4e18|\u8bb8\u660c|\u5e73\u9876\u5c71|\u5468\u53e3|\u6f2f\u6cb3|\u5357\u9633|\u9a7b\u9a6c\u5e97|\u4fe1\u9633)$?)", RegexOptions.IgnoreCase);
            if (matches.Count > 0)
            {
                return matches[0].Groups["content"].Value.Trim() + "市";
            }
            #endregion
            #region 湖北省
            province = "湖北省";
            matches = Regex.Matches(address, "(?<content>(\u6e56\u5317|\u6b66\u6c49|\u5341\u5830|\u8944\u6a0a|\u968f\u5dde|\u8346\u95e8|\u5b5d\u611f|\u5b9c\u660c|\u9ec4\u5188|\u9102\u5dde|\u8346\u5dde|\u9ec4\u77f3|\u54b8\u5b81)$?)", RegexOptions.IgnoreCase);
            if (matches.Count > 0)
            {
                return matches[0].Groups["content"].Value.Trim() + "市";
            }
            #endregion
            #region 湖南省
            province = "湖南省";
            matches = Regex.Matches(address, "(?<content>(\u6e56\u5357|\u957f\u6c99|\u5cb3\u9633|\u5f20\u5bb6\u754c|\u5e38\u5fb7|\u76ca\u9633|\u6e58\u6f6d|\u682a\u6d32|\u5a04\u5e95|\u6000\u5316|\u90b5\u9633|\u8861\u9633|\u6c38\u5dde|\u90f4\u5dde)$?)", RegexOptions.IgnoreCase);
            if (matches.Count > 0)
            {
                return matches[0].Groups["content"].Value.Trim() + "市";
            }
            #endregion
            #region 广东省
            province = "广东省";
            matches = Regex.Matches(address, "(?<content>(\u5e7f\u4e1c|\u5e7f\u5dde|\u97f6\u5173|\u6885\u5dde|\u6cb3\u6e90|\u6e05\u8fdc|\u6f6e\u5dde|\u63ed\u9633|\u6c55\u5934|\u8087\u5e86|\u60e0\u5dde|\u4f5b\u5c71|\u4e1c\u839e|\u4e91\u6d6e|\u6c55\u5c3e|\u6c5f\u95e8|\u4e2d\u5c71|\u6df1\u5733|\u73e0\u6d77|\u9633\u6c5f|\u8302\u540d|\u6e5b\u6c5f)$?)", RegexOptions.IgnoreCase);
            if (matches.Count > 0)
            {
                return matches[0].Groups["content"].Value.Trim() + "市";
            }
            #endregion
            #region 广西壮族自治区
            province = "广西壮族自治区";
            matches = Regex.Matches(address, "(?<content>(\u5e7f\u897f|\u5357\u5b81|\u6842\u6797|\u6cb3\u6c60|\u8d3a\u5dde|\u67f3\u5dde|\u767e\u8272|\u6765\u5bbe|\u68a7\u5dde|\u8d35\u6e2f|\u7389\u6797|\u5d07\u5de6|\u94a6\u5dde|\u9632\u57ce\u6e2f|\u5317\u6d77)$?)", RegexOptions.IgnoreCase);
            if (matches.Count > 0)
            {
                return matches[0].Groups["content"].Value.Trim() + "市";
            }
            #endregion
            #region 海南省
            province = "海南省";
            matches = Regex.Matches(address, "(?<content>(\u6d77\u5357|\u6d77\u53e3|\u4e09\u6c99|\u4e09\u4e9a)$?)", RegexOptions.IgnoreCase);
            if (matches.Count > 0)
            {
                return matches[0].Groups["content"].Value.Trim() + "市";
            }
            #endregion
            #region 四川省
            province = "四川省";
            matches = Regex.Matches(address, "(?<content>(\u56db\u5ddd|\u6210\u90fd|\u5e7f\u5143|\u5df4\u4e2d|\u7ef5\u9633|\u5fb7\u9633|\u8fbe\u5dde|\u5357\u5145|\u9042\u5b81|\u5e7f\u5b89|\u8d44\u9633|\u7709\u5c71|\u96c5\u5b89|\u5185\u6c5f|\u4e50\u5c71|\u81ea\u8d21|\u6cf8\u5dde|\u5b9c\u5bbe|\u6500\u679d\u82b1)$?)", RegexOptions.IgnoreCase);
            if (matches.Count > 0)
            {
                return matches[0].Groups["content"].Value.Trim() + "市";
            }
            #endregion
            #region 贵州省
            province = "贵州省";
            matches = Regex.Matches(address, "(?<content>(\u8d35\u5dde|\u8d35\u9633|\u9075\u4e49|\u94dc\u4ec1|\u6bd5\u8282|\u516d\u76d8\u6c34|\u5b89\u987a)$?)", RegexOptions.IgnoreCase);
            if (matches.Count > 0)
            {
                return matches[0].Groups["content"].Value.Trim() + "市";
            }
            #endregion
            #region 云南省
            province = "云南省";
            matches = Regex.Matches(address, "(?<content>(\u4e91\u5357|\u6606\u660e|\u662d\u901a|\u4e3d\u6c5f|\u66f2\u9756|\u4fdd\u5c71|\u7389\u6eaa|\u4e34\u6ca7|\u666e\u6d31)$?)", RegexOptions.IgnoreCase);
            if (matches.Count > 0)
            {
                return matches[0].Groups["content"].Value.Trim() + "市";
            }
            #endregion
            #region 西藏自治区
            province = "西藏自治区";
            matches = Regex.Matches(address, "(?<content>(\u897f\u85cf|\u62c9\u8428|\u660c\u90fd|\u65e5\u5580\u5219)$?)", RegexOptions.IgnoreCase);
            if (matches.Count > 0)
            {
                return matches[0].Groups["content"].Value.Trim() + "市";
            }
            #endregion
            #region 陕西省
            province = "陕西省";
            matches = Regex.Matches(address, "(?<content>(\u9655\u897f|\u897f\u5b89|\u6986\u6797|\u5ef6\u5b89|\u94dc\u5ddd|\u6e2d\u5357|\u5b9d\u9e21|\u54b8\u9633|\u5546\u6d1b|\u6c49\u4e2d|\u5b89\u5eb7)$?)", RegexOptions.IgnoreCase);
            if (matches.Count > 0)
            {
                return matches[0].Groups["content"].Value.Trim() + "市";
            }
            #endregion
            #region 甘肃省
            province = "甘肃省";
            matches = Regex.Matches(address, "(?<content>(\u7518\u8083|\u5170\u5dde|\u5609\u5cea\u5173|\u9152\u6cc9|\u5f20\u6396|\u91d1\u660c|\u6b66\u5a01|\u767d\u94f6|\u5e86\u9633|\u5e73\u51c9|\u5b9a\u897f|\u5929\u6c34|\u9647\u5357|\u6d77\u4e1c|\u000d\u000a)$?)", RegexOptions.IgnoreCase);
            if (matches.Count > 0)
            {
                return matches[0].Groups["content"].Value.Trim() + "市";
            }
            #endregion
            #region 青海省
            province = "青海省";
            matches = Regex.Matches(address, "(?<content>(\u9752\u6d77|\u897f\u5b81)$?)", RegexOptions.IgnoreCase);
            if (matches.Count > 0)
            {
                return matches[0].Groups["content"].Value.Trim() + "市";
            }
            #endregion
            #region 新疆维吾尔自治区
            province = "新疆维吾尔自治区";
            matches = Regex.Matches(address, "(?<content>(\u65b0\u7586|\u4e4c\u9c81\u6728\u9f50|\u514b\u62c9\u739b\u4f9d)$?)", RegexOptions.IgnoreCase);
            if (matches.Count > 0)
            {
                return matches[0].Groups["content"].Value.Trim() + "市";
            }
            #endregion
            #region 宁夏回族自治区
            province = "宁夏回族自治区";
            matches = Regex.Matches(address, "(?<content>(\u5b81\u590f|\u94f6\u5ddd|\u77f3\u5634\u5c71|\u5434\u5fe0|\u4e2d\u536b|\u56fa\u539f)$?)", RegexOptions.IgnoreCase);
            if (matches.Count > 0)
            {
                return matches[0].Groups["content"].Value.Trim() + "市";
            }
            #endregion
            #region 江苏省
            province = "江苏省";
            matches = Regex.Matches(address, "(?<content>(\u6c5f\u82cf|\u5357\u4eac|\u65e0\u9521|\u5f90\u5dde|\u5e38\u5dde|\u82cf\u5dde|\u5357\u901a|\u8fde\u4e91\u6e2f|\u6dee\u5b89|\u76d0\u57ce|\u626c\u5dde|\u9547\u6c5f|\u6cf0\u5dde|\u5bbf\u8fc1)$?)", RegexOptions.IgnoreCase);
            if (matches.Count > 0)
            {
                return matches[0].Groups["content"].Value.Trim() + "市";
            }
            #endregion
            province = "其它城市";
            return province;
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            //string province = "";
            //Address("浙江义乌市北下朱五懂684号", out province);
            //MessageBox.Show(province);
        }

        private void button1_Click(object sender, EventArgs e)
        {
            if (this.Text == "生成公章")
            {
                this.Text = "停止生成";
            }
            else
            {
                this.Text = "生成公章";
            }
            Microsoft.Office.Interop.Excel.Application excel = new Microsoft.Office.Interop.Excel.Application();
            Microsoft.Office.Interop.Excel.Workbook workbook;
            Microsoft.Office.Interop.Excel.Worksheet worksheet;
            object oMissing = System.Reflection.Missing.Value;//相当null
            workbook = excel.Workbooks.Open(txtFile.Text, oMissing, oMissing, oMissing, oMissing, oMissing, oMissing, oMissing, oMissing, oMissing, oMissing, oMissing, oMissing, oMissing, oMissing);
            worksheet = (Worksheet)workbook.Worksheets[1];
            int rowCount = worksheet.UsedRange.Rows.Count;
            int colCount = worksheet.UsedRange.Columns.Count;
            Microsoft.Office.Interop.Excel.Range range1;
            for (int j = 1; j < rowCount; j++)
            {
                range1 = worksheet.get_Range(worksheet.Cells[j + 1, 2], worksheet.Cells[j + 1, 2]);
                string ComName = range1.Value2.ToString();
                DrawCachetBitmap(ComName);
                list_dt.Items.Insert(0, "正在生成:" + ComName + " 公章");
                
            }
        }
        public void DrawCachetBitmap(string comname)
        {
            TestOnSeal _top = new TestOnSeal();
            _top.TextFont = new System.Drawing.Font("黑体", 16, FontStyle.Bold);
            _top.FillColor = Color.Red;
            //_top.ColorTOP = Color.Black;
            _top.Text = comname;
            _top.BaseString = "";
            _top.ShowPath = true;
            _top.LetterSpace = 1;
            _top.SealSize = 180;
            _top.CharDirection = Char_Direction.Center;
            _top.SetIndent(20);
            Graphics g = this.CreateGraphics();
            g.DrawImage(_top.TextOnPathBitmap(), 0, 0);

            _top.CharDirection = Char_Direction.ClockWise;
            g.DrawImage(_top.TextOnPathBitmap(), 180, 0);

            _top.CharDirection = Char_Direction.AntiClockWise;
            g.DrawImage(_top.TextOnPathBitmap(), 0, 180);

            _top.SetIndent(20);
            _top.CharDirection = Char_Direction.Center;
            g.DrawImage(_top.TextOnPathBitmap(), 180, 180);

            _top.TextOnPathBitmap().Save(System.Windows.Forms.Application.StartupPath + "/tp/" + comname + ".png",  System.Drawing.Imaging.ImageFormat.Png);

            g.Dispose();
        }
    }
}